From ac53197aba95e78d76828b185b17c97f4e36d754 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jul 30 2017 14:14:27 +0000
Subject: [PATCH 912/1001] Get widget parameter defaults more dynamically


---

diff --git a/hubs/models.py b/hubs/models.py
index 0a58e40..f894c22 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -28,6 +28,7 @@ import logging
 import operator
 import os
 import random
+from collections import defaultdict
 
 import bleach
 import sqlalchemy as sa
@@ -346,12 +347,18 @@ class HubConfig(BASE):
         return 12 - self.left_width
 
 
-def _widget_config_default(context):
-    widget_name = context.current_parameters['plugin']
-    widget = hubs.widgets.registry[widget_name]
-    return json.dumps(dict([
-        (param.name, param.default) for param in widget.get_parameters()
-        ]))
+class SpecificDefaultDict(defaultdict):
+    """A more specific version of defaultdict.
+
+    This class behaves like defaultdict, but calls the ``default_factory`` with
+    the key as first argument.
+    """
+
+    def __missing__(self, key):
+        if self.default_factory is None:
+            return super(SpecificDefaultDict, self).__missing__(key)
+        self[key] = self.default_factory(key)
+        return self[key]
 
 
 class Widget(ObjectAuthzMixin, BASE):
@@ -364,7 +371,7 @@ class Widget(ObjectAuthzMixin, BASE):
     plugin = sa.Column(sa.String(50), nullable=False)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
     hub_id = sa.Column(sa.String(50), sa.ForeignKey('hubs.name'))
-    _config = sa.Column(sa.Text, default=_widget_config_default)
+    _config = sa.Column(sa.Text, default="{}")
 
     index = sa.Column(sa.Integer, nullable=False)
     left = sa.Column(sa.Boolean, nullable=False, default=False)
@@ -388,7 +395,17 @@ class Widget(ObjectAuthzMixin, BASE):
 
     @property
     def config(self):
-        return json.loads(self._config)
+        def get_default(key):
+            for param in self.module.get_parameters():
+                if key == param.name:
+                    break
+            else:
+                raise KeyError("No such parameter")
+            return param.default
+
+        value = SpecificDefaultDict(get_default)
+        value.update(json.loads(self._config))
+        return value
 
     @config.setter
     def config(self, config):
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index aa8c5b8..7f35b37 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -9,6 +9,7 @@ import six
 from importlib import import_module
 from .caching import CachedFunction
 from .view import WidgetView
+from .validators import Validator
 
 
 log = logging.getLogger(__name__)
@@ -46,6 +47,9 @@ class WidgetParameter(object):
             setattr(self, name, kwargs.pop(name, None))
         for name in kwargs:
             raise TypeError("Invalid attribute: %s" % name)
+        # Set default validator
+        if self.validator is None:
+            self.validator = Validator
 
 
 class Widget(object):

